// -*- C++ -*-
//
// This file was generated by CLI, a command line interface
// compiler for C++.
//

#ifndef BPKG_COMMON_OPTIONS_HXX
#define BPKG_COMMON_OPTIONS_HXX

// Begin prologue.
//
//
// End prologue.

#include <deque>
#include <iosfwd>
#include <string>
#include <cstddef>
#include <exception>

#ifndef CLI_POTENTIALLY_UNUSED
#  if defined(_MSC_VER) || defined(__xlC__)
#    define CLI_POTENTIALLY_UNUSED(x) (void*)&x
#  else
#    define CLI_POTENTIALLY_UNUSED(x) (void)x
#  endif
#endif

namespace bpkg
{
  namespace cli
  {
    class usage_para
    {
      public:
      enum value
      {
        none,
        text,
        option
      };

      usage_para (value);

      operator value () const 
      {
        return v_;
      }

      private:
      value v_;
    };

    class unknown_mode
    {
      public:
      enum value
      {
        skip,
        stop,
        fail
      };

      unknown_mode (value);

      operator value () const 
      {
        return v_;
      }

      private:
      value v_;
    };

    // Exceptions.
    //

    class exception: public std::exception
    {
      public:
      virtual void
      print (::std::ostream&) const = 0;
    };

    ::std::ostream&
    operator<< (::std::ostream&, const exception&);

    class unknown_option: public exception
    {
      public:
      virtual
      ~unknown_option () throw ();

      unknown_option (const std::string& option);

      const std::string&
      option () const;

      virtual void
      print (::std::ostream&) const;

      virtual const char*
      what () const throw ();

      private:
      std::string option_;
    };

    class unknown_argument: public exception
    {
      public:
      virtual
      ~unknown_argument () throw ();

      unknown_argument (const std::string& argument);

      const std::string&
      argument () const;

      virtual void
      print (::std::ostream&) const;

      virtual const char*
      what () const throw ();

      private:
      std::string argument_;
    };

    class missing_value: public exception
    {
      public:
      virtual
      ~missing_value () throw ();

      missing_value (const std::string& option);

      const std::string&
      option () const;

      virtual void
      print (::std::ostream&) const;

      virtual const char*
      what () const throw ();

      private:
      std::string option_;
    };

    class invalid_value: public exception
    {
      public:
      virtual
      ~invalid_value () throw ();

      invalid_value (const std::string& option,
                     const std::string& value);

      const std::string&
      option () const;

      const std::string&
      value () const;

      virtual void
      print (::std::ostream&) const;

      virtual const char*
      what () const throw ();

      private:
      std::string option_;
      std::string value_;
    };

    class eos_reached: public exception
    {
      public:
      virtual void
      print (::std::ostream&) const;

      virtual const char*
      what () const throw ();
    };

    class file_io_failure: public exception
    {
      public:
      virtual
      ~file_io_failure () throw ();

      file_io_failure (const std::string& file);

      const std::string&
      file () const;

      virtual void
      print (::std::ostream&) const;

      virtual const char*
      what () const throw ();

      private:
      std::string file_;
    };

    class unmatched_quote: public exception
    {
      public:
      virtual
      ~unmatched_quote () throw ();

      unmatched_quote (const std::string& argument);

      const std::string&
      argument () const;

      virtual void
      print (::std::ostream&) const;

      virtual const char*
      what () const throw ();

      private:
      std::string argument_;
    };

    class scanner
    {
      public:
      virtual
      ~scanner ();

      virtual bool
      more () = 0;

      virtual const char*
      peek () = 0;

      virtual const char*
      next () = 0;

      virtual void
      skip () = 0;
    };

    class argv_scanner: public scanner
    {
      public:
      argv_scanner (int& argc, char** argv, bool erase = false);
      argv_scanner (int start, int& argc, char** argv, bool erase = false);

      int
      end () const;

      virtual bool
      more ();

      virtual const char*
      peek ();

      virtual const char*
      next ();

      virtual void
      skip ();

      private:
      int i_;
      int& argc_;
      char** argv_;
      bool erase_;
    };

    class vector_scanner: public scanner
    {
      public:
      vector_scanner (const std::vector<std::string>&, std::size_t start = 0);

      std::size_t
      end () const;

      virtual bool
      more ();

      virtual const char*
      peek ();

      virtual const char*
      next ();

      virtual void
      skip ();

      private:
      const std::vector<std::string>& v_;
      std::size_t i_;
    };

    class argv_file_scanner: public argv_scanner
    {
      public:
      argv_file_scanner (int& argc,
                         char** argv,
                         const std::string& option,
                         bool erase = false);

      argv_file_scanner (int start,
                         int& argc,
                         char** argv,
                         const std::string& option,
                         bool erase = false);

      struct option_info
      {
        // If search_func is not NULL, it is called, with the arg
        // value as the second argument, to locate the options file.
        // If it returns an empty string, then the file is ignored.
        //
        const char* option;
        std::string (*search_func) (const char*, void* arg);
        void* arg;
      };

      argv_file_scanner (int& argc,
                          char** argv,
                          const option_info* options,
                          std::size_t options_count,
                          bool erase = false);

      argv_file_scanner (int start,
                         int& argc,
                         char** argv,
                         const option_info* options,
                         std::size_t options_count,
                         bool erase = false);

      virtual bool
      more ();

      virtual const char*
      peek ();

      virtual const char*
      next ();

      virtual void
      skip ();

      private:
      const option_info*
      find (const char*) const;

      void
      load (const std::string& file);

      typedef argv_scanner base;

      const std::string option_;
      option_info option_info_;
      const option_info* options_;
      std::size_t options_count_;

      std::string hold_;
      std::deque<std::string> args_;
      bool skip_;
    };

    template <typename X>
    struct parser;
  }
}

#include <set>

#include <bpkg/types.hxx>

#include <bpkg/options-types.hxx>

namespace bpkg
{
  class common_options
  {
    public:
    // Option accessors.
    //
    const bool&
    v () const;

    const bool&
    V () const;

    const bool&
    quiet () const;

    const uint16_t&
    verbose () const;

    bool
    verbose_specified () const;

    const path&
    build () const;

    bool
    build_specified () const;

    const strings&
    build_option () const;

    bool
    build_option_specified () const;

    const path&
    fetch () const;

    bool
    fetch_specified () const;

    const strings&
    fetch_option () const;

    bool
    fetch_option_specified () const;

    const path&
    sha256 () const;

    bool
    sha256_specified () const;

    const strings&
    sha256_option () const;

    bool
    sha256_option_specified () const;

    const path&
    tar () const;

    bool
    tar_specified () const;

    const strings&
    tar_option () const;

    bool
    tar_option_specified () const;

    const path&
    openssl () const;

    bool
    openssl_specified () const;

    const strings&
    openssl_option () const;

    bool
    openssl_option_specified () const;

    const bpkg::auth&
    auth () const;

    bool
    auth_specified () const;

    const std::set<string>&
    trust () const;

    bool
    trust_specified () const;

    const bool&
    trust_yes () const;

    const bool&
    trust_no () const;

    const string&
    pager () const;

    bool
    pager_specified () const;

    const strings&
    pager_option () const;

    bool
    pager_option_specified () const;

    const string&
    options_file () const;

    bool
    options_file_specified () const;

    // Print usage information.
    //
    static ::bpkg::cli::usage_para
    print_usage (::std::ostream&,
                 ::bpkg::cli::usage_para = ::bpkg::cli::usage_para::none);

    static ::bpkg::cli::usage_para
    print_long_usage (::std::ostream&,
                      ::bpkg::cli::usage_para = ::bpkg::cli::usage_para::none);

    // Implementation details.
    //
    protected:
    common_options ();

    bool
    _parse (const char*, ::bpkg::cli::scanner&);

    public:
    bool v_;
    bool V_;
    bool quiet_;
    uint16_t verbose_;
    bool verbose_specified_;
    path build_;
    bool build_specified_;
    strings build_option_;
    bool build_option_specified_;
    path fetch_;
    bool fetch_specified_;
    strings fetch_option_;
    bool fetch_option_specified_;
    path sha256_;
    bool sha256_specified_;
    strings sha256_option_;
    bool sha256_option_specified_;
    path tar_;
    bool tar_specified_;
    strings tar_option_;
    bool tar_option_specified_;
    path openssl_;
    bool openssl_specified_;
    strings openssl_option_;
    bool openssl_option_specified_;
    bpkg::auth auth_;
    bool auth_specified_;
    std::set<string> trust_;
    bool trust_specified_;
    bool trust_yes_;
    bool trust_no_;
    string pager_;
    bool pager_specified_;
    strings pager_option_;
    bool pager_option_specified_;
    string options_file_;
    bool options_file_specified_;
  };
}

// Print page usage information.
//
namespace bpkg
{
  ::bpkg::cli::usage_para
  print_bpkg_common_options_usage (::std::ostream&,
                                   ::bpkg::cli::usage_para = ::bpkg::cli::usage_para::none);

  ::bpkg::cli::usage_para
  print_bpkg_common_options_long_usage (::std::ostream&,
                                        ::bpkg::cli::usage_para = ::bpkg::cli::usage_para::none);
}

#include <bpkg/common-options.ixx>

// Begin epilogue.
//
//
// End epilogue.

#endif // BPKG_COMMON_OPTIONS_HXX
